submodule: Use cat instead of echo to avoid DOS line-endings
[git/dscho.git] / git-submodule.sh
blob5bec652114f2c1386857d040fe2fe2602bae6994
1 #!/bin/sh
3 # git-submodules.sh: add, init, update or list git submodules
5 # Copyright (c) 2007 Lars Hjemli
7 dashless=$(basename "$0" | sed -e 's/-/ /')
8 USAGE="[--quiet] add [-b branch] [-f|--force] [--reference <repository>] [--] <repository> [<path>]
9 or: $dashless [--quiet] status [--cached] [--recursive] [--] [<path>...]
10 or: $dashless [--quiet] init [--] [<path>...]
11 or: $dashless [--quiet] update [--init] [-N|--no-fetch] [-f|--force] [--rebase] [--reference <repository>] [--merge] [--recursive] [--] [<path>...]
12 or: $dashless [--quiet] summary [--cached|--files] [--summary-limit <n>] [commit] [--] [<path>...]
13 or: $dashless [--quiet] foreach [--recursive] <command>
14 or: $dashless [--quiet] sync [--] [<path>...]"
15 OPTIONS_SPEC=
16 . git-sh-setup
17 . git-sh-i18n
18 . git-parse-remote
19 require_work_tree
21 command=
22 branch=
23 force=
24 reference=
25 cached=
26 recursive=
27 init=
28 files=
29 nofetch=
30 update=
31 prefix=
33 # Resolve relative url by appending to parent's url
34 resolve_relative_url ()
36 remote=$(get_default_remote)
37 remoteurl=$(git config "remote.$remote.url") ||
38 remoteurl=$(pwd) # the repository is its own authoritative upstream
39 url="$1"
40 remoteurl=${remoteurl%/}
41 sep=/
42 while test -n "$url"
44 case "$url" in
45 ../*)
46 url="${url#../}"
47 case "$remoteurl" in
48 */*)
49 remoteurl="${remoteurl%/*}"
51 *:*)
52 remoteurl="${remoteurl%:*}"
53 sep=:
56 die "$(eval_gettext "cannot strip one component off url '\$remoteurl'")"
58 esac
60 ./*)
61 url="${url#./}"
64 break;;
65 esac
66 done
67 echo "$remoteurl$sep${url%/}"
71 # Get submodule info for registered submodules
72 # $@ = path to limit submodule list
74 module_list()
76 git ls-files --error-unmatch --stage -- "$@" |
77 perl -e '
78 my %unmerged = ();
79 my ($null_sha1) = ("0" x 40);
80 while (<STDIN>) {
81 chomp;
82 my ($mode, $sha1, $stage, $path) =
83 /^([0-7]+) ([0-9a-f]{40}) ([0-3])\t(.*)$/;
84 next unless $mode eq "160000";
85 if ($stage ne "0") {
86 if (!$unmerged{$path}++) {
87 print "$mode $null_sha1 U\t$path\n";
89 next;
91 print "$_\n";
97 # Map submodule path to submodule name
99 # $1 = path
101 module_name()
103 # Do we have "submodule.<something>.path = $1" defined in .gitmodules file?
104 re=$(printf '%s\n' "$1" | sed -e 's/[].[^$\\*]/\\&/g')
105 name=$( git config -f .gitmodules --get-regexp '^submodule\..*\.path$' |
106 sed -n -e 's|^submodule\.\(.*\)\.path '"$re"'$|\1|p' )
107 test -z "$name" &&
108 die "$(eval_gettext "No submodule mapping found in .gitmodules for path '\$path'")"
109 echo "$name"
113 # Clone a submodule
115 # Prior to calling, cmd_update checks that a possibly existing
116 # path is not a git repository.
117 # Likewise, cmd_add checks that path does not exist at all,
118 # since it is the location of a new submodule.
120 module_clone()
122 path=$1
123 url=$2
124 reference="$3"
125 quiet=
126 if test -n "$GIT_QUIET"
127 then
128 quiet=-q
131 gitdir=
132 gitdir_base=
133 name=$(module_name "$path" 2>/dev/null)
134 test -n "$name" || name="$path"
135 base_name=$(dirname "$name")
137 gitdir=$(git rev-parse --git-dir)
138 gitdir_base="$gitdir/modules/$base_name"
139 gitdir="$gitdir/modules/$name"
141 if test -d "$gitdir"
142 then
143 mkdir -p "$path"
144 rm -f "$gitdir/index"
145 else
146 mkdir -p "$gitdir_base"
147 git clone $quiet -n ${reference:+"$reference"} \
148 --separate-git-dir "$gitdir" "$url" "$path" ||
149 die "$(eval_gettext "Clone of '\$url' into submodule path '\$path' failed")"
152 a=$(cd "$gitdir" && pwd)/
153 b=$(cd "$path" && pwd)/
154 # normalize Windows-style absolute paths to POSIX-style absolute paths
155 case $a in [a-zA-Z]:/*) a=/${a%%:*}${a#*:} ;; esac
156 case $b in [a-zA-Z]:/*) b=/${b%%:*}${b#*:} ;; esac
157 # Remove all common leading directories after a sanity check
158 if test "${a#$b}" != "$a" || test "${b#$a}" != "$b"; then
159 die "$(eval_gettext "Gitdir '\$a' is part of the submodule path '\$b' or vice versa")"
161 while test "${a%%/*}" = "${b%%/*}"
163 a=${a#*/}
164 b=${b#*/}
165 done
166 # Now chop off the trailing '/'s that were added in the beginning
167 a=${a%/}
168 b=${b%/}
170 rel=$(echo $b | sed -e 's|[^/]*|..|g')
171 echo "gitdir: $rel/$a" >"$path/.git"
173 rel=$(echo $a | sed -e 's|[^/]*|..|g')
174 (clear_local_git_env; cd "$path" && GIT_WORK_TREE=. git config core.worktree "$rel/$b")
178 # Add a new submodule to the working tree, .gitmodules and the index
180 # $@ = repo path
182 # optional branch is stored in global branch variable
184 cmd_add()
186 # parse $args after "submodule ... add".
187 while test $# -ne 0
189 case "$1" in
190 -b | --branch)
191 case "$2" in '') usage ;; esac
192 branch=$2
193 shift
195 -f | --force)
196 force=$1
198 -q|--quiet)
199 GIT_QUIET=1
201 --reference)
202 case "$2" in '') usage ;; esac
203 reference="--reference=$2"
204 shift
206 --reference=*)
207 reference="$1"
208 shift
211 shift
212 break
215 usage
218 break
220 esac
221 shift
222 done
224 repo=$1
225 path=$2
227 if test -z "$path"; then
228 path=$(echo "$repo" |
229 sed -e 's|/$||' -e 's|:*/*\.git$||' -e 's|.*[/:]||g')
232 if test -z "$repo" -o -z "$path"; then
233 usage
236 # assure repo is absolute or relative to parent
237 case "$repo" in
238 ./*|../*)
239 # dereference source url relative to parent's url
240 realrepo=$(resolve_relative_url "$repo") || exit
242 *:*|/*)
243 # absolute url
244 realrepo=$repo
247 die "$(eval_gettext "repo URL: '\$repo' must be absolute or begin with ./|../")"
249 esac
251 # normalize path:
252 # multiple //; leading ./; /./; /../; trailing /
253 path=$(printf '%s/\n' "$path" |
254 sed -e '
255 s|//*|/|g
256 s|^\(\./\)*||
257 s|/\./|/|g
258 :start
259 s|\([^/]*\)/\.\./||
260 tstart
261 s|/*$||
263 git ls-files --error-unmatch "$path" > /dev/null 2>&1 &&
264 die "$(eval_gettext "'\$path' already exists in the index")"
266 if test -z "$force" && ! git add --dry-run --ignore-missing "$path" > /dev/null 2>&1
267 then
268 eval_gettextln "The following path is ignored by one of your .gitignore files:
269 \$path
270 Use -f if you really want to add it." >&2
271 exit 1
274 # perhaps the path exists and is already a git repo, else clone it
275 if test -e "$path"
276 then
277 if test -d "$path"/.git -o -f "$path"/.git
278 then
279 eval_gettextln "Adding existing repo at '\$path' to the index"
280 else
281 die "$(eval_gettext "'\$path' already exists and is not a valid git repo")"
284 else
286 module_clone "$path" "$realrepo" "$reference" || exit
288 clear_local_git_env
289 cd "$path" &&
290 # ash fails to wordsplit ${branch:+-b "$branch"...}
291 case "$branch" in
292 '') git checkout -f -q ;;
293 ?*) git checkout -f -q -B "$branch" "origin/$branch" ;;
294 esac
295 ) || die "$(eval_gettext "Unable to checkout submodule '\$path'")"
297 git config submodule."$path".url "$realrepo"
299 git add $force "$path" ||
300 die "$(eval_gettext "Failed to add submodule '\$path'")"
302 git config -f .gitmodules submodule."$path".path "$path" &&
303 git config -f .gitmodules submodule."$path".url "$repo" &&
304 git add --force .gitmodules ||
305 die "$(eval_gettext "Failed to register submodule '\$path'")"
309 # Execute an arbitrary command sequence in each checked out
310 # submodule
312 # $@ = command to execute
314 cmd_foreach()
316 # parse $args after "submodule ... foreach".
317 while test $# -ne 0
319 case "$1" in
320 -q|--quiet)
321 GIT_QUIET=1
323 --recursive)
324 recursive=1
327 usage
330 break
332 esac
333 shift
334 done
336 toplevel=$(pwd)
338 # dup stdin so that it can be restored when running the external
339 # command in the subshell (and a recursive call to this function)
340 exec 3<&0
342 module_list |
343 while read mode sha1 stage path
345 if test -e "$path"/.git
346 then
347 say "$(eval_gettext "Entering '\$prefix\$path'")"
348 name=$(module_name "$path")
350 prefix="$prefix$path/"
351 clear_local_git_env
352 cd "$path" &&
353 eval "$@" &&
354 if test -n "$recursive"
355 then
356 cmd_foreach "--recursive" "$@"
358 ) <&3 3<&- ||
359 die "$(eval_gettext "Stopping at '\$path'; script returned non-zero status.")"
361 done
365 # Register submodules in .git/config
367 # $@ = requested paths (default to all)
369 cmd_init()
371 # parse $args after "submodule ... init".
372 while test $# -ne 0
374 case "$1" in
375 -q|--quiet)
376 GIT_QUIET=1
379 shift
380 break
383 usage
386 break
388 esac
389 shift
390 done
392 module_list "$@" |
393 while read mode sha1 stage path
395 # Skip already registered paths
396 name=$(module_name "$path") || exit
397 if test -z "$(git config "submodule.$name.url")"
398 then
399 url=$(git config -f .gitmodules submodule."$name".url)
400 test -z "$url" &&
401 die "$(eval_gettext "No url found for submodule path '\$path' in .gitmodules")"
403 # Possibly a url relative to parent
404 case "$url" in
405 ./*|../*)
406 url=$(resolve_relative_url "$url") || exit
408 esac
409 git config submodule."$name".url "$url" ||
410 die "$(eval_gettext "Failed to register url for submodule path '\$path'")"
413 # Copy "update" setting when it is not set yet
414 upd="$(git config -f .gitmodules submodule."$name".update)"
415 test -z "$upd" ||
416 test -n "$(git config submodule."$name".update)" ||
417 git config submodule."$name".update "$upd" ||
418 die "$(eval_gettext "Failed to register update mode for submodule path '\$path'")"
420 say "$(eval_gettext "Submodule '\$name' (\$url) registered for path '\$path'")"
421 done
425 # Update each submodule path to correct revision, using clone and checkout as needed
427 # $@ = requested paths (default to all)
429 cmd_update()
431 # parse $args after "submodule ... update".
432 orig_flags=
433 while test $# -ne 0
435 case "$1" in
436 -q|--quiet)
437 GIT_QUIET=1
439 -i|--init)
440 init=1
442 -N|--no-fetch)
443 nofetch=1
445 -f|--force)
446 force=$1
448 -r|--rebase)
449 update="rebase"
451 --reference)
452 case "$2" in '') usage ;; esac
453 reference="--reference=$2"
454 orig_flags="$orig_flags $(git rev-parse --sq-quote "$1")"
455 shift
457 --reference=*)
458 reference="$1"
460 -m|--merge)
461 update="merge"
463 --recursive)
464 recursive=1
466 --checkout)
467 update="checkout"
470 shift
471 break
474 usage
477 break
479 esac
480 orig_flags="$orig_flags $(git rev-parse --sq-quote "$1")"
481 shift
482 done
484 if test -n "$init"
485 then
486 cmd_init "--" "$@" || return
489 cloned_modules=
490 module_list "$@" | {
491 err=
492 while read mode sha1 stage path
494 if test "$stage" = U
495 then
496 echo >&2 "Skipping unmerged submodule $path"
497 continue
499 name=$(module_name "$path") || exit
500 url=$(git config submodule."$name".url)
501 if ! test -z "$update"
502 then
503 update_module=$update
504 else
505 update_module=$(git config submodule."$name".update)
508 if test "$update_module" = "none"
509 then
510 echo "Skipping submodule '$path'"
511 continue
514 if test -z "$url"
515 then
516 # Only mention uninitialized submodules when its
517 # path have been specified
518 test "$#" != "0" &&
519 say "$(eval_gettext "Submodule path '\$path' not initialized
520 Maybe you want to use 'update --init'?")"
521 continue
524 if ! test -d "$path"/.git -o -f "$path"/.git
525 then
526 module_clone "$path" "$url" "$reference"|| exit
527 cloned_modules="$cloned_modules;$name"
528 subsha1=
529 else
530 subsha1=$(clear_local_git_env; cd "$path" &&
531 git rev-parse --verify HEAD) ||
532 die "$(eval_gettext "Unable to find current revision in submodule path '\$path'")"
535 if test "$subsha1" != "$sha1"
536 then
537 subforce=$force
538 # If we don't already have a -f flag and the submodule has never been checked out
539 if test -z "$subsha1" -a -z "$force"
540 then
541 subforce="-f"
544 if test -z "$nofetch"
545 then
546 # Run fetch only if $sha1 isn't present or it
547 # is not reachable from a ref.
548 (clear_local_git_env; cd "$path" &&
549 ( (rev=$(git rev-list -n 1 $sha1 --not --all 2>/dev/null) &&
550 test -z "$rev") || git-fetch)) ||
551 die "$(eval_gettext "Unable to fetch in submodule path '\$path'")"
554 # Is this something we just cloned?
555 case ";$cloned_modules;" in
556 *";$name;"*)
557 # then there is no local change to integrate
558 update_module= ;;
559 esac
561 must_die_on_failure=
562 case "$update_module" in
563 rebase)
564 command="git rebase"
565 die_msg="$(eval_gettext "Unable to rebase '\$sha1' in submodule path '\$path'")"
566 say_msg="$(eval_gettext "Submodule path '\$path': rebased into '\$sha1'")"
567 must_die_on_failure=yes
569 merge)
570 command="git merge"
571 die_msg="$(eval_gettext "Unable to merge '\$sha1' in submodule path '\$path'")"
572 say_msg="$(eval_gettext "Submodule path '\$path': merged in '\$sha1'")"
573 must_die_on_failure=yes
576 command="git checkout $subforce -q"
577 die_msg="$(eval_gettext "Unable to checkout '\$sha1' in submodule path '\$path'")"
578 say_msg="$(eval_gettext "Submodule path '\$path': checked out '\$sha1'")"
580 esac
582 if (clear_local_git_env; cd "$path" && $command "$sha1")
583 then
584 say "$say_msg"
585 elif test -n "$must_die_on_failure"
586 then
587 die_with_status 2 "$die_msg"
588 else
589 err="${err};$die_msg"
590 continue
594 if test -n "$recursive"
595 then
596 (clear_local_git_env; cd "$path" && eval cmd_update "$orig_flags")
597 res=$?
598 if test $res -gt 0
599 then
600 die_msg="$(eval_gettext "Failed to recurse into submodule path '\$path'")"
601 if test $res -eq 1
602 then
603 err="${err};$die_msg"
604 continue
605 else
606 die_with_status $res "$die_msg"
610 done
612 if test -n "$err"
613 then
614 OIFS=$IFS
615 IFS=';'
616 for e in $err
618 if test -n "$e"
619 then
620 echo >&2 "$e"
622 done
623 IFS=$OIFS
624 exit 1
629 set_name_rev () {
630 revname=$( (
631 clear_local_git_env
632 cd "$1" && {
633 git describe "$2" 2>/dev/null ||
634 git describe --tags "$2" 2>/dev/null ||
635 git describe --contains "$2" 2>/dev/null ||
636 git describe --all --always "$2"
639 test -z "$revname" || revname=" ($revname)"
642 # Show commit summary for submodules in index or working tree
644 # If '--cached' is given, show summary between index and given commit,
645 # or between working tree and given commit
647 # $@ = [commit (default 'HEAD'),] requested paths (default all)
649 cmd_summary() {
650 summary_limit=-1
651 for_status=
652 diff_cmd=diff-index
654 # parse $args after "submodule ... summary".
655 while test $# -ne 0
657 case "$1" in
658 --cached)
659 cached="$1"
661 --files)
662 files="$1"
664 --for-status)
665 for_status="$1"
667 -n|--summary-limit)
668 if summary_limit=$(($2 + 0)) 2>/dev/null && test "$summary_limit" = "$2"
669 then
671 else
672 usage
674 shift
677 shift
678 break
681 usage
684 break
686 esac
687 shift
688 done
690 test $summary_limit = 0 && return
692 if rev=$(git rev-parse -q --verify --default HEAD ${1+"$1"})
693 then
694 head=$rev
695 test $# = 0 || shift
696 elif test -z "$1" -o "$1" = "HEAD"
697 then
698 # before the first commit: compare with an empty tree
699 head=$(git hash-object -w -t tree --stdin </dev/null)
700 test -z "$1" || shift
701 else
702 head="HEAD"
705 if [ -n "$files" ]
706 then
707 test -n "$cached" &&
708 die "$(gettext -- "--cached cannot be used with --files")"
709 diff_cmd=diff-files
710 head=
713 cd_to_toplevel
714 # Get modified modules cared by user
715 modules=$(git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- "$@" |
716 sane_egrep '^:([0-7]* )?160000' |
717 while read mod_src mod_dst sha1_src sha1_dst status name
719 # Always show modules deleted or type-changed (blob<->module)
720 test $status = D -o $status = T && echo "$name" && continue
721 # Also show added or modified modules which are checked out
722 GIT_DIR="$name/.git" git-rev-parse --git-dir >/dev/null 2>&1 &&
723 echo "$name"
724 done
727 test -z "$modules" && return
729 git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- $modules |
730 sane_egrep '^:([0-7]* )?160000' |
731 cut -c2- |
732 while read mod_src mod_dst sha1_src sha1_dst status name
734 if test -z "$cached" &&
735 test $sha1_dst = 0000000000000000000000000000000000000000
736 then
737 case "$mod_dst" in
738 160000)
739 sha1_dst=$(GIT_DIR="$name/.git" git rev-parse HEAD)
741 100644 | 100755 | 120000)
742 sha1_dst=$(git hash-object $name)
744 000000)
745 ;; # removed
747 # unexpected type
748 eval_gettextln "unexpected mode \$mod_dst" >&2
749 continue ;;
750 esac
752 missing_src=
753 missing_dst=
755 test $mod_src = 160000 &&
756 ! GIT_DIR="$name/.git" git-rev-parse -q --verify $sha1_src^0 >/dev/null &&
757 missing_src=t
759 test $mod_dst = 160000 &&
760 ! GIT_DIR="$name/.git" git-rev-parse -q --verify $sha1_dst^0 >/dev/null &&
761 missing_dst=t
763 total_commits=
764 case "$missing_src,$missing_dst" in
766 errmsg="$(eval_gettext " Warn: \$name doesn't contain commit \$sha1_src")"
769 errmsg="$(eval_gettext " Warn: \$name doesn't contain commit \$sha1_dst")"
771 t,t)
772 errmsg="$(eval_gettext " Warn: \$name doesn't contain commits \$sha1_src and \$sha1_dst")"
775 errmsg=
776 total_commits=$(
777 if test $mod_src = 160000 -a $mod_dst = 160000
778 then
779 range="$sha1_src...$sha1_dst"
780 elif test $mod_src = 160000
781 then
782 range=$sha1_src
783 else
784 range=$sha1_dst
786 GIT_DIR="$name/.git" \
787 git rev-list --first-parent $range -- | wc -l
789 total_commits=" ($(($total_commits + 0)))"
791 esac
793 sha1_abbr_src=$(echo $sha1_src | cut -c1-7)
794 sha1_abbr_dst=$(echo $sha1_dst | cut -c1-7)
795 if test $status = T
796 then
797 blob="$(gettext "blob")"
798 submodule="$(gettext "submodule")"
799 if test $mod_dst = 160000
800 then
801 echo "* $name $sha1_abbr_src($blob)->$sha1_abbr_dst($submodule)$total_commits:"
802 else
803 echo "* $name $sha1_abbr_src($submodule)->$sha1_abbr_dst($blob)$total_commits:"
805 else
806 echo "* $name $sha1_abbr_src...$sha1_abbr_dst$total_commits:"
808 if test -n "$errmsg"
809 then
810 # Don't give error msg for modification whose dst is not submodule
811 # i.e. deleted or changed to blob
812 test $mod_dst = 160000 && echo "$errmsg"
813 else
814 if test $mod_src = 160000 -a $mod_dst = 160000
815 then
816 limit=
817 test $summary_limit -gt 0 && limit="-$summary_limit"
818 GIT_DIR="$name/.git" \
819 git log $limit --pretty='format: %m %s' \
820 --first-parent $sha1_src...$sha1_dst
821 elif test $mod_dst = 160000
822 then
823 GIT_DIR="$name/.git" \
824 git log --pretty='format: > %s' -1 $sha1_dst
825 else
826 GIT_DIR="$name/.git" \
827 git log --pretty='format: < %s' -1 $sha1_src
829 echo
831 echo
832 done |
833 if test -n "$for_status"; then
834 if [ -n "$files" ]; then
835 status_msg="$(gettextln "# Submodules changed but not updated:")"
836 else
837 status_msg="$(gettextln "# Submodule changes to be committed:")"
839 status_sed=$(sed -e 's|^|# |' -e 's|^# $|#|')
840 cat <<EOF
841 $status_msg
843 $status_sed
845 else
850 # List all submodules, prefixed with:
851 # - submodule not initialized
852 # + different revision checked out
854 # If --cached was specified the revision in the index will be printed
855 # instead of the currently checked out revision.
857 # $@ = requested paths (default to all)
859 cmd_status()
861 # parse $args after "submodule ... status".
862 orig_flags=
863 while test $# -ne 0
865 case "$1" in
866 -q|--quiet)
867 GIT_QUIET=1
869 --cached)
870 cached=1
872 --recursive)
873 recursive=1
876 shift
877 break
880 usage
883 break
885 esac
886 orig_flags="$orig_flags $(git rev-parse --sq-quote "$1")"
887 shift
888 done
890 module_list "$@" |
891 while read mode sha1 stage path
893 name=$(module_name "$path") || exit
894 url=$(git config submodule."$name".url)
895 displaypath="$prefix$path"
896 if test "$stage" = U
897 then
898 say "U$sha1 $displaypath"
899 continue
901 if test -z "$url" || ! test -d "$path"/.git -o -f "$path"/.git
902 then
903 say "-$sha1 $displaypath"
904 continue;
906 set_name_rev "$path" "$sha1"
907 if git diff-files --ignore-submodules=dirty --quiet -- "$path"
908 then
909 say " $sha1 $displaypath$revname"
910 else
911 if test -z "$cached"
912 then
913 sha1=$(clear_local_git_env; cd "$path" && git rev-parse --verify HEAD)
914 set_name_rev "$path" "$sha1"
916 say "+$sha1 $displaypath$revname"
919 if test -n "$recursive"
920 then
922 prefix="$displaypath/"
923 clear_local_git_env
924 cd "$path" &&
925 eval cmd_status "$orig_args"
926 ) ||
927 die "$(eval_gettext "Failed to recurse into submodule path '\$path'")"
929 done
932 # Sync remote urls for submodules
933 # This makes the value for remote.$remote.url match the value
934 # specified in .gitmodules.
936 cmd_sync()
938 while test $# -ne 0
940 case "$1" in
941 -q|--quiet)
942 GIT_QUIET=1
943 shift
946 shift
947 break
950 usage
953 break
955 esac
956 done
957 cd_to_toplevel
958 module_list "$@" |
959 while read mode sha1 stage path
961 name=$(module_name "$path")
962 url=$(git config -f .gitmodules --get submodule."$name".url)
964 # Possibly a url relative to parent
965 case "$url" in
966 ./*|../*)
967 url=$(resolve_relative_url "$url") || exit
969 esac
971 if git config "submodule.$name.url" >/dev/null 2>/dev/null
972 then
973 say "$(eval_gettext "Synchronizing submodule url for '\$name'")"
974 git config submodule."$name".url "$url"
976 if test -e "$path"/.git
977 then
979 clear_local_git_env
980 cd "$path"
981 remote=$(get_default_remote)
982 git config remote."$remote".url "$url"
986 done
989 # This loop parses the command line arguments to find the
990 # subcommand name to dispatch. Parsing of the subcommand specific
991 # options are primarily done by the subcommand implementations.
992 # Subcommand specific options such as --branch and --cached are
993 # parsed here as well, for backward compatibility.
995 while test $# != 0 && test -z "$command"
997 case "$1" in
998 add | foreach | init | update | status | summary | sync)
999 command=$1
1001 -q|--quiet)
1002 GIT_QUIET=1
1004 -b|--branch)
1005 case "$2" in
1007 usage
1009 esac
1010 branch="$2"; shift
1012 --cached)
1013 cached="$1"
1016 break
1019 usage
1022 break
1024 esac
1025 shift
1026 done
1028 # No command word defaults to "status"
1029 test -n "$command" || command=status
1031 # "-b branch" is accepted only by "add"
1032 if test -n "$branch" && test "$command" != add
1033 then
1034 usage
1037 # "--cached" is accepted only by "status" and "summary"
1038 if test -n "$cached" && test "$command" != status -a "$command" != summary
1039 then
1040 usage
1043 "cmd_$command" "$@"